C# Класс Revit.SDK.Samples.ShaftHolePuncher.CS.Profile

base class of ProfileFloor, ProfileWall and ProfileNull. contains the profile information and can calculate matrix to transform point to 2D plane
Показать файл Открыть проект Примеры использования класса

Защищенные свойства (Protected)

Свойство Тип Описание
m_appCreator Autodesk.Revit.Creation.Application
m_commandData Autodesk.Revit.UI.ExternalCommandData
m_docCreator Autodesk.Revit.Creation.Document
m_moveToCenterMatrix Matrix4
m_points List>
m_restoreMatrix Matrix4
m_scaleMatrix Matrix4
m_sizePictureBox System.Drawing.Size
m_to2DMatrix Matrix4
m_transformMatrix Matrix4

Открытые методы

Метод Описание
Compute3DTo2DMatrix ( ) : Matrix4

calculate the matrix used to transform 3D to 2D

ComputeScaleMatrix ( Size size ) : Matrix4

calculate the matrix use to scale

CreateOpening ( List points ) : Opening

abstract method to create Opening

Draw2D ( Graphics graphics, Pen pen, Matrix4 matrix4 ) : void

draw profile of wall or floor in 2D

GetFaceBounds ( ) : System.Drawing.PointF[]

Get the bound of a face

GetFaceNormal ( List face ) : Vector4

Get normal of face

GetFaces ( Autodesk elem ) : List>

Get edges of element's profile

GetNeedPoints ( List faces ) : List>

Get points in first face

GetTo2DMatrix ( ) : Matrix4

Get a matrix which can transform points to 2D

ToCenterMatrix ( ) : Matrix4

Get a matrix which can move points to center

Transform2DTo3D ( Point ps ) : List

transform the point on Form to 3d world coordinate of revit

Защищенные методы

Метод Описание
Profile ( ExternalCommandData commandData ) : System

constructor

Приватные методы

Метод Описание
TransformPoints ( Point pts ) : void

use matrix to transform point

Описание методов

Compute3DTo2DMatrix() публичный Метод

calculate the matrix used to transform 3D to 2D
public Compute3DTo2DMatrix ( ) : Matrix4
Результат Matrix4

ComputeScaleMatrix() публичный Метод

calculate the matrix use to scale
public ComputeScaleMatrix ( Size size ) : Matrix4
size System.Drawing.Size pictureBox size
Результат Matrix4

CreateOpening() публичный абстрактный Метод

abstract method to create Opening
public abstract CreateOpening ( List points ) : Opening
points List points used to create Opening
Результат Opening

Draw2D() публичный Метод

draw profile of wall or floor in 2D
public Draw2D ( Graphics graphics, Pen pen, Matrix4 matrix4 ) : void
graphics System.Drawing.Graphics form graphic
pen System.Drawing.Pen pen used to draw line in pictureBox
matrix4 Matrix4 Matrix used to transform 3d to 2d /// and make picture in right scale
Результат void

GetFaceBounds() публичный Метод

Get the bound of a face
public GetFaceBounds ( ) : System.Drawing.PointF[]
Результат System.Drawing.PointF[]

GetFaceNormal() публичный Метод

Get normal of face
public GetFaceNormal ( List face ) : Vector4
face List edges in a face
Результат Vector4

GetFaces() публичный Метод

Get edges of element's profile
public GetFaces ( Autodesk elem ) : List>
elem Autodesk selected element
Результат List>

GetNeedPoints() публичный Метод

Get points in first face
public GetNeedPoints ( List faces ) : List>
faces List edges in all faces
Результат List>

GetTo2DMatrix() публичный Метод

Get a matrix which can transform points to 2D
public GetTo2DMatrix ( ) : Matrix4
Результат Matrix4

Profile() защищенный Метод

constructor
protected Profile ( ExternalCommandData commandData ) : System
commandData ExternalCommandData object which contains reference to Revit Application
Результат System

ToCenterMatrix() публичный Метод

Get a matrix which can move points to center
public ToCenterMatrix ( ) : Matrix4
Результат Matrix4

Transform2DTo3D() публичный Метод

transform the point on Form to 3d world coordinate of revit
public Transform2DTo3D ( Point ps ) : List
ps System.Drawing.Point contain the points to be transformed
Результат List

Описание свойств

m_appCreator защищенное свойство

protected Autodesk.Revit.Creation.Application m_appCreator
Результат Autodesk.Revit.Creation.Application

m_commandData защищенное свойство

protected ExternalCommandData,Autodesk.Revit.UI m_commandData
Результат Autodesk.Revit.UI.ExternalCommandData

m_docCreator защищенное свойство

protected Autodesk.Revit.Creation.Document m_docCreator
Результат Autodesk.Revit.Creation.Document

m_moveToCenterMatrix защищенное свойство

protected Matrix4,Revit.SDK.Samples.ShaftHolePuncher.CS m_moveToCenterMatrix
Результат Matrix4

m_points защищенное свойство

protected List> m_points
Результат List>

m_restoreMatrix защищенное свойство

protected Matrix4,Revit.SDK.Samples.ShaftHolePuncher.CS m_restoreMatrix
Результат Matrix4

m_scaleMatrix защищенное свойство

protected Matrix4,Revit.SDK.Samples.ShaftHolePuncher.CS m_scaleMatrix
Результат Matrix4

m_sizePictureBox защищенное свойство

protected Size,System.Drawing m_sizePictureBox
Результат System.Drawing.Size

m_to2DMatrix защищенное свойство

protected Matrix4,Revit.SDK.Samples.ShaftHolePuncher.CS m_to2DMatrix
Результат Matrix4

m_transformMatrix защищенное свойство

protected Matrix4,Revit.SDK.Samples.ShaftHolePuncher.CS m_transformMatrix
Результат Matrix4